SellOMatic = LibStub("AceAddon-3.0"):NewAddon("SellOMatic", "AceEvent-3.0", "AceConsole-3.0");
local SellOMatic = _G.SellOMatic

local function getOption(info)
	return (info.arg and SellOMatic.db.profile[info.arg] or SellOMatic.db.profile[info[#info]]);
end;

local function setOption(info, value)
	local key = info.arg or info[#info];
	SellOMatic.db.profile[key] = value;
end;

local options = {
	name = "Sell-O-Matic",
	handler = SellOMatic,
	type = "group",
	args = {
		general = {
			type = "group",
			name = "General Options",
			guiInline = true,
			args = {
				autoSell = {
					name = "Auto sell",
					desc = "Toggle ON/OFF automatic mode.",
					order = 1,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				showFullInfo = {
					name = "Information type",
					desc = "Choose the type of information",
					order = 2,
					type = "select",
					values = {
						["1-FULL"] = "FULL",
						["2-SUMMARY"] = "SUMMARY",
						["3-LITE"] = "LITE",
					},
					style = "dropdown",
					get = getOption,
					set = setOption,
				},
				showDetail = {
					name = "Show detail",
					desc = "Toggle ON/OFF item sell detail.",
					order = 3,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				showAdditionalButtons = {
					name = "Show +/- buttons",
					desc = "Toggle ON/OFF showing add/del buttons.",
					order = 10,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
			},
		},
	},
}

local defaults = {
	profile = {
		-- CORE
		autoSell = false,
		showFullInfo = "FULL",
		showDetail = false,
		showAdditionalButtons = false,
		-- ITEM
		allowWhite = false,
		allowBlue = false,
		allowEpic = false,
		allowBoP = false,
		allowBoE = false,
		iLevelValue = 1,
		useILevel = false,
		-- LIST
		sellList = {},
		saveList = {},
		useList = false,
		caseSensitiveList = false,
		list_allowBoP = false,
		list_allowBoE = false,
		list_allowWhite = false,
		list_allowBlue = false,
		list_allowEpic = false,
		list_useILevel = false,
		list_iLevelValue = 1,
	},
}

function SellOMatic:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("SellOMaticDB", defaults, "Default");
	LibStub("AceConfig-3.0"):RegisterOptionsTable("SellOMatic", options);
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("SellOMatic", "Sell-O-Matic");
	local SOM_List = LoadAddOn("SellOMatic_List");
	local SOM_Item = LoadAddOn("SellOMatic_Item");
	local SOM_Destroy = LoadAddOn("SellOMatic_Destroy");
end;

function SellOMatic:OnEnable()
--	self:Print("List: "..SOM_List);
	if not SOM_Destroy then
		self:Print("Dest not loaded");
	end;
end;

-- Scan items and call other modules
-- Save all items in array
-- Display merchant animation if array has items
-- Display merchant value if array has items
-- Sell items
